// Ardu_terra first relase
// made by Eldzi
// Based on Terra_control with my modification


//Functionality:
//LCD 1602
//Sending data on the Thinger
//Control lightht by NTP clock
//Settimo Thanks for the Davide Nardella

#include <NTPClient.h>
#include <ESP8266WiFi.h>
#include <ESP8266mDNS.h>
#include <WiFiUdp.h>
#include <ArduinoOTA.h>
#include <DHT.h>    // DHT sensor library
#include <ThingerESP8266.h>
#include <Wire.h>  // I2C library already built in Arduino IDE
#include <LiquidCrystal_I2C.h> //library via Include Library > Manage Library > 

#include "Platform.h"
#include "Settimino.h"


LiquidCrystal_I2C lcd(0x27,2,1,0,4,5,6,7); //0x27 is i2c address, EN,RW ,RS ,D4,D5,D6,D7 
#ifndef STASSID
#define STASSID "xxxxx"
#define STAPSK  "xxxxxxxxxx"
#endif

#define USERNAME "xxx"
#define DEVICE_ID "xxx"
#define DEVICE_CREDENTIAL "xxx"

#define SSID "xxxx"
#define SSID_PASSWORD "xxxx"

//Constants
#define SENSOR_IN 4                        // Terrarium sensor pin
#define SENSOR_IN_Type DHT11               // DHT22
#define RELAY_Light 14                     // Pin no.4 - Light relay
#define RELAY_Heat 15                       // Pin no.5 - Heat relay
#define RELAY_hum 16  
#define RELAY_Moon 5 

const char* ssid = STASSID;
const char* password = STAPSK;

//Variables and  default settings
float set_delay = 80;       //Set delay for loop (30s)
int hum_min = 60;             //Set MINimum humidity level
int hum_max = 70;             //Set MAXimum humidity level
int temp_min = 23;            //Set MINimim temperature
int temp_max = 32;            //Set MAXimum temperature
int Light_on = 6;  
int Light_off = 22;
int Moon_on = 20;
int Moon_off = 5;

boolean light_value;
boolean heat_value;
boolean moon_value;
boolean hum_value;

int light_state;
int heat_state;
int moon_state;
int hum_state;

float hum;                    //Stores humidity value
float temp;                     //Stores temperature value
float hum_old;                    //Stores humidity value
float temp_old;
int temperature;
int humidity;
float hum_room;               //Stores room humidity value
float temp_room;              //Stores room temperature value
char line0[16];
char line1[16];
String weekDays[7]={"Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"};
String months[12]={"January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"};
byte status_word;
int DBNum = 61; // This DB must be present in your PLC

word Data_write[26];
word Data_read[26];



WiFiUDP ntpUDP;
NTPClient timeClient(ntpUDP, "pool.ntp.org");
DHT dht_in(SENSOR_IN, SENSOR_IN_Type);     // Initialize DHT sensor for 16mhz Arduino
byte mac[] = { 0x28, 0x63, 0x36, 0x88, 0xc5, 0x69 };
IPAddress Local(192,168,1,xx); // Local Address
IPAddress PLC(192,168,1,xx);   // PLC Address
IPAddress Gateway(192, 168, 1, 1);
IPAddress Subnet(255, 255, 255, 0);
S7Client Client;
ThingerESP8266 thing(USERNAME, DEVICE_ID, DEVICE_CREDENTIAL);

//[][][][][][][][]][[]][][][][]][][][][][][][][][][][][][][][]  SETUP  [][][][]][[]][][][][]][][][][][][][][][][][][][][][][][][][]][[]][][][][]][][][][][][][][][][][][][][][][][][][]][[]][][][][]][][][][][][][][][][][]

unsigned long Elapsed; // To calc the execution time

void setup() {
  Serial.begin(9600);
  Serial.println("Booting");
  WiFi.mode(WIFI_STA);
  WiFi.begin(ssid, password);
  while (WiFi.waitForConnectResult() != WL_CONNECTED) {
    Serial.println("Connection Failed! Rebooting...");
    delay(50);
    Serial.print(".");
    ESP.restart();  
}   
   // activate LCD module
 lcd.begin (16,2); // for 16 x 2 LCD module
 lcd.setBacklightPin(3,POSITIVE);
 lcd.setBacklight(HIGH);
 lcd.home();
 lcd.setCursor(0, 1); 
 lcd.backlight();
 lcd.clear();
 
 thing.add_wifi(SSID, SSID_PASSWORD);
 dht_in.begin();
 timeClient.begin();
 timeClient.setTimeOffset(7200);      

// OTA
  ArduinoOTA.onStart([]() {
    String type;
    if (ArduinoOTA.getCommand() == U_FLASH) {
      type = "sketch";
    } else { // U_FS
      type = "filesystem";
    }
    // NOTE: if updating FS this would be the place to unmount FS using FS.end()
    Serial.println("Start updating " + type);
  });
  ArduinoOTA.onEnd([]() {
    Serial.println("\nEnd");
  });
  ArduinoOTA.onProgress([](unsigned int progress, unsigned int total) {
    Serial.printf("Progress: %u%%\r", (progress / (total / 100)));
  });
  ArduinoOTA.onError([](ota_error_t error) {
    Serial.printf("Error[%u]: ", error);
    if (error == OTA_AUTH_ERROR) {
      Serial.println("Auth Failed");
    } else if (error == OTA_BEGIN_ERROR) {
      Serial.println("Begin Failed");
    } else if (error == OTA_CONNECT_ERROR) {
      Serial.println("Connect Failed");
    } else if (error == OTA_RECEIVE_ERROR) {
      Serial.println("Receive Failed");
    } else if (error == OTA_END_ERROR) {
      Serial.println("End Failed");
    }
  });
  ArduinoOTA.begin();
  Serial.println("Ready");
  Serial.print("IP address: ");
  Serial.println(WiFi.localIP());

// Seting pins as output
pinMode(15, OUTPUT);
pinMode(16, OUTPUT);
pinMode(12, OUTPUT);
pinMode(14, OUTPUT);
pinMode(5, OUTPUT);
lcd.clear();  
lcd.noCursor();
}
// PLC connection 
   bool Connect()
{
    int Result=Client.ConnectTo(PLC, 
                                  0,  // Rack (see the doc.)
                                  0); // Slot (see the doc.)
    Serial.print("Connecting to ");Serial.println(PLC);  
    if (Result==0) 
    {
      Serial.print("Connected ! PDU Length = ");Serial.println(Client.GetPDULength());
    }
    else
      Serial.println("Connection error");
    return Result==0;
}
void CheckError(int ErrNo)
{
  Serial.print("Error No. 0x");
  Serial.println(ErrNo, HEX);
  
  // Checks if it's a Severe Error => we need to disconnect
  if (ErrNo & 0x00FF)
  {
    Serial.println("SEVERE ERROR, disconnecting.");
    Client.Disconnect(); 
  }
}
void MarkTime()
{
  Elapsed=millis();
}
void ShowTime()
{
  // Calcs the time
  Elapsed=millis()-Elapsed;
  Serial.print("Job time (ms) : ");
  Serial.println(Elapsed);   
}

//[][][][][][][][]][[]][][][][]][][][][][][][][][][][][][][][][][][]LOOOP[]][[]][][][][]][][][][][][][][][][][][][][][][][][][]][[]][][][][]][][][][][][][][][][][][][][][][][][][]][[]][][][][]][][][][][][][][][][][]
void loop() {
  
ArduinoOTA.handle();
control();
PLCs();
  delay(400);
}

//[][][][][][][][]][[]][][][][]][][][][][][][][][][][][][][][][][][]CONTROL[]][[]][][][][]][][][][][][][][][][][][][][][][][][][]][[]][][][][]][][][][][][][][][][][][][][][][][][][]][[]][][][][]][][][][][][][][][][][]
void control(){
  thing.handle();
  timeClient.update();

  light_value = digitalRead(RELAY_Light);        //Read pin values (1 = ON, 0 = OFF)
  heat_value = digitalRead(RELAY_Heat);
  hum_value = digitalRead(RELAY_hum);
  moon_value = digitalRead(RELAY_Moon);

  hum = dht_in.readHumidity();                   //Read hum and temp data
  temp = dht_in.readTemperature();

       for (int i = 0; i < 15; i++) {                 // Print line for separating single loops
        Serial.print("_ . -");
        delay(40);
        }
        Serial.print("\n");
     
           int currentHour = timeClient.getHours();
           Serial.print("Hour: ");
           Serial.println(currentHour); 
  
    // check the messurement Validity, if not correct then send last correct value
        if ((temp > 40 || temp < 15) && (hum > 100 || hum < 1) || ( isnan(temp)&&isnan(hum) ) ) {                                        
                                Serial.print("\n");
                                Serial.println("Read Error - Last correct value");
                                 //lcd.print("Read Error - Last correct value");
                                Serial.print("Temperature: ");                  //Print out temperature and humidity values
                                Serial.print(temp_old);
                                Serial.print(" Celsius, Humidity: ");
                                Serial.print(hum_old);
                                Serial.println("%");
                                  thing["Temp"] >> outputValue(temp_old);
                                  thing["HUM"] >> outputValue(hum_old);
                                }
                                else
                                {
    
   
        Serial.print("Temperature: ");                  //Print out temperature and humidity values
        Serial.print(temp);
        temp_old = temp;
        temperature = temp;    
        humidity = hum;                                     
                
        Serial.print(" Celsius, Humidity: ");
        Serial.print(hum);
        Serial.println("%");  
        hum_old = hum;                
                      
        thing["Temp"] >> outputValue(temp);
        thing["HUM"] >> outputValue(hum);
                                }
  
  //Checking temperature
if ((temp > 40 || temp < 15) && (hum > 100 || hum < 1) || ( isnan(temp)&&isnan(hum) ) ) {  
                                                                     
                                Serial.println("Do nothing - wait on update the value");
     }                                
else {
             if (temp < temp_min) { //check MIN_temp and if the heat is OFF
                digitalWrite(RELAY_Heat, LOW);                  //turn heat ON when temperature is below temp_min and the heating is OFF
                Serial.println("Heat ON.");
              }
                    else if (temp > temp_max) { //check MAX_temp and if the heat is ON
                      digitalWrite(RELAY_Heat, HIGH);                  //turn heat OFF when temperature is above temp_max and the heating is ON
                      Serial.println("Heat OFF");
                    }
                                        else {
                                          Serial.println("Temperature OK.");
                                        }
                   
  //Checking humidity
  if (hum <= hum_min) {          //check hum_min
    Serial.println("Humidity too LOW. Humidifier ON");
    digitalWrite(RELAY_hum, LOW);
  }
        else if (hum >= hum_max) {   //check hum_min
          Serial.println("Humidity too HIGH.");
          digitalWrite(RELAY_hum, HIGH); 
        }
              else {
                Serial.println("Humidity OK.");
              }
}

// control light
if (Light_off > currentHour && currentHour > Light_on) {          
    Serial.println("Day Mode");
     lcd.setCursor(1, 0);
    lcd.print("Dzienny tryb"); 
     digitalWrite(RELAY_Moon, HIGH);
     digitalWrite(RELAY_Light, LOW);
  }
        else if ((Light_off < currentHour && currentHour < Moon_on) ||(Moon_off < currentHour && currentHour < Light_on)){
          Serial.println("Night");
           digitalWrite(RELAY_Moon, HIGH);
           digitalWrite(RELAY_Light, HIGH);
            lcd.setCursor(2, 0);
    lcd.print("Nocny Tryb"); 
     }
     else {
          Serial.println("Night - Moon");
           digitalWrite(RELAY_Moon, LOW);
           digitalWrite(RELAY_Light, HIGH);
            lcd.setCursor(2, 0);
    lcd.print("Nocny Tryb - K"); 
     }

    lcd.setCursor(0, 1);
    lcd.print("Temp=");
     lcd.print(temperature,DEC); 
     lcd.print(" ");
     lcd.print("Wilg=");
      lcd.print(humidity,DEC); 

}
//[][][][][][][][]][[]][][][][]][][][][][][][][][][][][][][][][][][] MODBUS []][[]][][][][]][][][][][][][][][][][][][][][][][][][]][[]][][][
void PLCs(){   

int Size, Result;
  void *Target;

light_state = light_value;
heat_state = heat_value;
moon_state = moon_value;
hum_state =  hum_value;
  
  // Connection
  while (!Client.Connected)
  {
    if (!Connect())
      delay(500);
  }

for (int i = 0; i < 15; i++) {                 // Print line for separating single loops
   Serial.print("-.-");
   delay(40);
   }
    Serial.print("\n");

Data_write[0] = temperature;
Data_write[1] = humidity;
Data_write[2] = Light_on;
Data_write[3] = Light_off;
Data_write[4] = hum_min;
Data_write[5] = hum_max;    
Data_write[6] = temp_min;
Data_write[7] = temp_max; 
Data_write[8] = Moon_on;
Data_write[9] = Moon_off;
Data_write[10] = light_state;
Data_write[11] = heat_state;
Data_write[12] = hum_state;
Data_write[13] = moon_state;


Result=Client.WriteArea(S7AreaDB, // We are requesting DB access
                         61,        // DB Number = 1
                         100,        // Start from byte N.0
                         28,     // We need "Size" bytes
                         Data_write);  // Put them into our target (Buffer or PDU
if (Result==0)
  { ShowTime(); }
else{ CheckError(Result); }
  delay(500);
Result=Client.ReadArea(S7AreaDB, // We are requesting DB access
                         61,        // DB Number = 1
                         128,        // Start from byte N.0
                         16,     // We need "Size" bytes
                         Data_read);  // Put them into our target (Buffer or PDU

  if (Result==0)
  { ShowTime(); }
  else{ CheckError(Result);}

 
 

Light_on = Data_read[0];
Light_off = Data_read[1];
hum_min = Data_read[2];
hum_max = Data_read[3];
temp_min = Data_read[4];
temp_max = Data_read[5];
Moon_on = Data_read[6];
Moon_off = Data_read[7];

}
